using System;
using System.Collections.Generic;
using System.Text;

namespace QD_GUI
{
    public class Index
    {
        /* <!ELEMENT index            (
         *                             number,
         *                             status,
         *                             points?,
         *                             points_per_hour?,
         *                             progress_rate?,
         *                             progress?,
         *                             server*,
         *                             project_number?,
         *                             project_name?,
         *                             genome*,
         *                             folding*,
         *                             issue_timestamp?,
         *                             begin_timestamp?,
         *                             end_timestamp?,
         *                             expect_timestamp?,
         *                             due_timestamp?,
         *                             expire_timestamp?,
         *                             deadline?,
         *                             preferred_timestamp?,
         *                             preferred_deadline?,
         *                             core?,
         *                             cpu?,
         *                             os?,
         *                             smp_cores?,
         *                             tag?,
         *                             memory?,
         *                             assignment_info?,
         *                             collection_server?,
         *                             download_timestamp?,
         *                             upload_failures?,
         *                             packet_size_limit?,
         *                             qgen?,
         *                             username?,
         *                             team?,
         *                             id?,
         *                             machine_id?,
         *                             work_unit?
         *                            )>
         * 
         * 
         * QueueDump.Queue.Index[0].Number
         * QueueDump.Queue.Index[0].Status
         * QueueDump.Queue.Index[0].Points
         * QueueDump.Queue.Index[0].PointsPerHour
         * QueueDump.Queue.Index[0].ProgressRate
         * QueueDump.Queue.Index[0].Progress
         * QueueDump.Queue.Index[0].Server[0].Number
         * QueueDump.Queue.Index[0].Server[0].Address
         * QueueDump.Queue.Index[0].Server[1].Number
         * QueueDump.Queue.Index[0].Server[1].Address
         * QueueDump.Queue.Index[0].ProjectNumber
         * QueueDump.Queue.Index[0].ProjectName
         * QueueDump.Queue.Index[0].Genome.Unit
         * QueueDump.Queue.Index[0].Genome.Benchmark
         * QueueDump.Queue.Index[0].Genome.Misc
         * QueueDump.Queue.Index[0].Genome.Other
         * QueueDump.Queue.Index[0].Folding.Run
         * QueueDump.Queue.Index[0].Folding.Clone
         * QueueDump.Queue.Index[0].Folding.Generation
         * QueueDump.Queue.Index[0].Folding.Benchmark
         * QueueDump.Queue.Index[0].Folding.Misc
         * QueueDump.Queue.Index[0].Folding.Other
         * QueueDump.Queue.Index[0].IssueTimestamp
         * QueueDump.Queue.Index[0].BeginTimestamp
         * QueueDump.Queue.Index[0].EndTimestamp
         * QueueDump.Queue.Index[0].ExpectTimestamp
         * QueueDump.Queue.Index[0].DueTimestamp
         * QueueDump.Queue.Index[0].ExpireTimestamp
         * QueueDump.Queue.Index[0].Deadline
         * QueueDump.Queue.Index[0].Core.URL
         * QueueDump.Queue.Index[0].Core.Version
         * QueueDump.Queue.Index[0].CPU.CosmType
         * QueueDump.Queue.Index[0].CPU.CosmSubtype
         * QueueDump.Queue.Index[0].CPU.Name
         * QueueDump.Queue.Index[0].OS.CosmType
         * QueueDump.Queue.Index[0].OS.CosmSubtype
         * QueueDump.Queue.Index[0].OS.Name
         * QueueDump.Queue.Index[0].SMPCores
         * QueueDump.Queue.Index[0].Tag
         * QueueDump.Queue.Index[0].Memory
         * QueueDump.Queue.Index[0].AssignmentInfo.ByteOrder
         * QueueDump.Queue.Index[0].AssignmentInfo.Timestamp
         * QueueDump.Queue.Index[0].AssignmentInfo.Checksum
         * QueueDump.Queue.Index[0].CollectionServer
         * QueueDump.Queue.Index[0].DownloadTimestamp
         * QueueDump.Queue.Index[0].UploadFailures
         * QueueDump.Queue.Index[0].PacketSizeLimit
         * QueueDump.Queue.Index[0].Qgen
         * QueueDump.Queue.Index[0].Username
         * QueueDump.Queue.Index[0].Team
         * QueueDump.Queue.Index[0].ID
         * QueueDump.Queue.Index[0].MachineID
         * QueueDump.Queue.Index[0].WorkUnit.File
         * QueueDump.Queue.Index[0].WorkUnit.Size
         * QueueDump.Queue.Index[0].WorkUnit.Type
         * ...
         * QueueDump.Queue.Index[9]
         */

        private string sNumber = "";
        private string sStatus = "";
        private string sPoints = "";
        private string sPointsPerHour = "";
        private string sProgressRate = "";
        private string sProgress = "";
        private Server[] oServer = new Server[2];
        private string sProjectNumber = "";
        private string sProjectName = "";
        private Genome oGenome = new Genome();
        private Folding oFolding = new Folding();
        private string sIssueTimestamp = "";
        private string sBeginTimestamp = "";
        private string sEndTimestamp = "";
        private string sExpectTimestamp = "";
        private string sDueTimestamp = "";
        private string sExpireTimestamp = "";
        private string sDeadline = "";
        private string sPreferredTimestamp = "";
        private string sPreferredDeadline = "";
        private Core oCore = new Core();
        private CPUOSType oCPU = new CPUOSType();
        private CPUOSType oOS = new CPUOSType();
        private string sSMPCores = "";
        private string sTag = "";
        private string sMemory = "";
        private AssignmentInfo oAssignmentInfo = new AssignmentInfo();
        private string sCollectionServer = "";
        private string sDownloadTimestamp= "";
        private string sUploadFailures = "";
        private string sPacketSizeLimit = "";
        private string sQgen = "";
        private string sUsername = "";
        private string sTeam = "";
        private string sID = "";
        private string sMachineID = "";
        private WorkUnit oWorkUnit = new WorkUnit();

        #region Properties

        public string Number
        {
            get
            {
                return sNumber;
            }
            set
            {
                sNumber = value;
            }
        }

        public string Status
        {
            get
            {
                return sStatus;
            }
            set
            {
                sStatus = value;
            }
        }

        public string Points
        {
            get
            {
                return sPoints;
            }
            set
            {
                sPoints = value;
            }
        }

        public string PointsPerHour
        {
            get
            {
                return sPointsPerHour;
            }
            set
            {
                sPointsPerHour = value;
            }
        }

        public string ProgressRate
        {
            get
            {
                return sProgressRate;
            }
            set
            {
                sProgressRate = value;
            }
        }

        public string Progress
        {
            get
            {
                return sProgress;
            }
            set
            {
                sProgress = value;
            }
        }

        public Server[] Server
        {
            get
            {
                return oServer;
            }
            set
            {
                oServer = value;
            }
        }

        public string ProjectNumber
        {
            get
            {
                return sProjectNumber;
            }
            set 
            {
                sProjectNumber = value;
            }
        }
        public string ProjectName
        {
            get
            {
                return sProjectName;
            }
            set
            {
                sProjectName = value;
            }
        }

        public Genome Genome
        {
            get
            {
                return oGenome;
            }
            set
            {
                oGenome = value;
            }
        }

        public Folding Folding
        {
            get
            {
                return oFolding;
            }
            set
            {
                oFolding = value;
            }
        }

        public string IssueTimestamp
        {
            get
            {
                return sIssueTimestamp;
            }
            set
            {
                sIssueTimestamp = value;
            }
        }

        public string BeginTimestamp
        {
            get
            {
                return sBeginTimestamp;
            }
            set
            {
                sBeginTimestamp = value;
            }
        }

        public string EndTimestamp
        {
            get
            {
                return sEndTimestamp;
            }
            set
            {
                sEndTimestamp = value;
            }
        }

        public string ExpectTimestamp
        {
            get
            {
                return sExpectTimestamp;
            }
            set
            {
                sExpectTimestamp = value;
            }
        }

        public string DueTimestamp
        {
            get
            {
                return sDueTimestamp;
            }
            set
            {
                sDueTimestamp = value;
            }
        }

        public string ExpireTimestamp
        {
            get
            {
                return sExpireTimestamp;
            }
            set
            {
                sExpireTimestamp = value;
            }
        }

        public string Deadline
        {
            get
            {
                return sDeadline;
            }
            set
            {
                sDeadline = value;
            }
        }

        public string PreferredTimestamp
        {
            get
            {
                return sPreferredTimestamp;
            }
            set
            {
                sPreferredTimestamp = value;
            }
        }

        public string PreferredDeadline
        {
            get
            {
                return sPreferredDeadline;
            }
            set
            {
                sPreferredDeadline = value;
            }
        }

        public Core Core
        {
            get
            {
                return oCore;
            }
            set
            {
                oCore = value;
            }
        }

        public CPUOSType CPU
        {
            get
            {
                return oCPU;
            }
            set
            {
                oCPU = value;
            }
        }

        public CPUOSType OS
        {
            get
            {
                return oOS;
            }
            set
            {
                oOS = value;
            }
        }

        public string SMPCores
        {
            get
            {
                return sSMPCores;
            }
            set
            {
                sSMPCores = value;
            }
        }

        public string Tag
        {
            get
            {
                return sTag;
            }
            set
            {
                sTag = value;
            }
        }

        public string Memory
        {
            get
            {
                return sMemory;
            }
            set
            {
                sMemory = value;
            }
        }
        
        public AssignmentInfo AssignmentInfo
        {
            get
            {
                return oAssignmentInfo;
            }
            set
            {
                oAssignmentInfo = value;
            }
        }

        public string CollectionServer
        {
            get
            {
                return sCollectionServer;
            }
            set
            {
                sCollectionServer = value;
            }
        }

        public string DownloadTimestamp
        {
            get
            {
                return sDownloadTimestamp;
            }
            set
            {
                sDownloadTimestamp = value;
            }
        }

        public string UploadFailures
        {
            get
            {
                return sUploadFailures;
            }
            set
            {
                sUploadFailures = value;
            }
        }

        public string PacketSizeLimit
        {
            get
            {
                return sPacketSizeLimit;
            }
            set
            {
                sPacketSizeLimit = value;
            }
        }

        public string Qgen
        {
            get
            {
                return sQgen;
            }
            set
            {
                sQgen = value;
            }
        }

        public string Username
        {
            get
            {
                return sUsername;
            }
            set
            {
                sUsername = value;
            }
        }

        public string Team
        {
            get
            {
                return sTeam;
            }
            set
            {
                sTeam = value;
            }
        }

        public string ID
        {
            get
            {
                return sID;
            }
            set
            {
                sID = value;
            }
        }

        public string MachineID
        {
            get
            {
                return sMachineID;
            }
            set
            {
                sMachineID = value;
            }
        }

        public WorkUnit WorkUnit
        {
            get
            {
                return oWorkUnit;
            }
            set
            {
                oWorkUnit = value;
            }
        }

        #endregion Properties
    }
}
